#include <omniORB4/CORBA.h>
#include "AddrBook_impl.h"
#include <fstream>
#include <iostream> // fuer cout

using namespace std;

int main(int argc, char * argv[]) {
	int rc = 0;

	try {
		// Get a reference to an ORB object
		CORBA::ORB_var orb = CORBA::ORB_init(argc , argv);

		// Get a reference to a POA object
		CORBA::Object_var poaobj = orb->resolve_initial_references("RootPOA");
		// down - cast CORBA :: Object_var into
		// the type PortableServer :: POA_var
		PortableServer::POA_var poa = PortableServer::POA::_narrow(poaobj);
		if(CORBA::is_nil(poa)) {
			cerr<<"konnte POA nicht erzeugen !"<<endl;
			return 1;
		}
		
		// POA - Manager anlegen
		PortableServer::POAManager_var mgr = poa->the_POAManager();
		
		// Servant anlegen
		AddrBook_impl * servant = new AddrBook_impl();
		
		// Servant aktivieren
		AddrBook_var f = servant->_this();
		
		CORBA::String_var s = orb->object_to_string(f);
		ofstream out("AddrBook.ref");
		out<<s<<endl;
		out.close();
		
		mgr->activate();
		orb->run();

		// TRUE war bei "mico" gross geschrieben
		poa->destroy(true, true);
		delete servant;
		rc = 0;
		
	} catch (CORBA::SystemException & ex) {
		cerr<<ex._name()<<endl;
		rc = 1;
	}
	return rc;
}
